<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/24/2004 *
 * ================                             Last change: 08/09/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-del_holiday.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Remove holiday requests                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Urlaubsschaltungen entfernen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Check for selected holidays
$SUM = 0;
if (REQUEST_ISSET_POST('sel')) $SUM = SELECTION_COUNT(REQUEST_POST('sel'));

// Shall I delete selected holidays???
if ($SUM > 0)
{
	// Delete multiple holiday requests (for list_holiday)
	$cnt = 0;
	foreach (REQUEST_POST('sel') as $id => $sel)
	{
		// Get the userid
		$result = SQL_QUERY_ESC("SELECT userid, holiday_start, holiday_end
FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE id=%s LIMIT 1", array(bigintval($id)), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1)
		{
			// Load data and free memory
			list($uid, $start, $end) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Update user's account
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data`
SET holiday_active='N', holiday_activated='0'
WHERE userid=%s LIMIT 1", array(bigintval($uid)), __FILE__, __LINE__);

			// Remove holiday
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE id=%s LIMIT 1", array(bigintval($id)), __FILE__, __LINE__);

			// Prepare loaded data for the
			$content = array(
				'start' => MAKE_DATETIME($start, "3"),
				'end'   => MAKE_DATETIME($end  , "3")
			);

			// Send email to user
			$msg = LOAD_EMAIL_TEMPLATE("member_holiday_removed", $content, $uid);
			SEND_EMAIL($uid, getMessage('HOLIDAY_ADMIN_REMOVED_SUBJ'), $msg);
			$cnt++;
		}
	}
	LOAD_TEMPLATE("admin_settings_saved", false, sprintf(getMessage('HOLIDAY_ADMIN_MULTI_DEL'), $cnt));
} elseif (REQUEST_ISSET_GET(('uid'))) {
	// Set default message
	$MSG = getMessage('HOLIDAY_ADMIN_SINGLE_404');

	// Fetch data
	$result_load = SQL_QUERY_ESC("SELECT holiday_start AS start, holiday_end AS end
FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s LIMIT 1", array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result_load) == 1) {
		// Load data
		$content = SQL_FETCHARRAY($result_load);

		// Delete one holiday request (for task)
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s LIMIT 1", array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);

		// Send email to user
		$msg = LOAD_EMAIL_TEMPLATE("member_holiday_removed", $content, REQUEST_GET('uid'));
		SEND_EMAIL(REQUEST_GET('uid'), getMessage('HOLIDAY_ADMIN_REMOVED_SUBJ'), $msg);

		// Set message
		$MSG = getMessage('HOLIDAY_ADMIN_SINGLE_DELETED');
	}

	// Free memory
	SQL_FREERESULT($result_load);

	// Output message
	LOAD_TEMPLATE("admin_settings_saved", false, $MSG);
} else {
	// Please call me over other scripts... ;)
	LOAD_TEMPLATE("admin_settings_saved", false, getMessage('HOLIDAY_NO_DIRECT_CALL'));
}

//
?>
